/* SCCS  @(#)nsl_model.h	1.1---95/08/13--23:37:18 */
//
// 	nsl_model.h
//

class nsl_model : public nsl_public
{
protected:
	float DELTA;		// time step

	float SYS_TIME;		// absolute time

	float CURRENT_TIME;	// current time
	int CURRENT_TIME_STEP;

	float END_TIME;		// end time
	int END_TIME_STEP;

	int layer_total; 	// total number of layers
	nsl_list* layer_list; 	// pointer to all nsl layers

	int module_total; 	// total number of run modules
	nsl_list* module_list; 	// pointer to all nsl modules

	nsl_diff_manager* DIFFM;	// diff information

public:
		nsl_model(const char*,int=0);
		nsl_model();
		~nsl_model();

	int init_model(const char*,int=0);

// get
	float get_delta() { return DELTA; }
	float get_sys_time() { return SYS_TIME; }
	float get_time() { return CURRENT_TIME; }
	float get_end_time() { return END_TIME; }
	float get_current_time() { return CURRENT_TIME; }
	int get_time_step() { return CURRENT_TIME_STEP; }
	int get_current_time_step() { return CURRENT_TIME_STEP; }
	int get_end_time_step() { return END_TIME_STEP; }
	nsl_diff_manager* get_diff_manager() { return DIFFM; }
 
// set
	void 	set_delta(float);
	void	set_sys_time(float f) { SYS_TIME = f; }
	void 	set_time(float);
	void 	set_time(int); // check out this
	void 	set_end_time(float);
	void 	set_current_time(float f) { set_time(f); }
	void 	set_time_step(int);
	void 	set_end_time_step(int);
	void 	set_current_time_step(int f) { set_time(f); }
	void 	set_diff_manager(nsl_diff_manager* d) { DIFFM = d; }

// reset time
	void reset_time();
// increment time 
	void incr_time();
	void incr_sys_time() { SYS_TIME++; }

// layers
	int 	get_layer_total() { return layer_total; }
	nsl_list* get_layer_list() { return layer_list; }

	int	add_layer(nsl_layer*);

	nsl_layer*	get_layer();		// get first layer
	nsl_layer*	get_layer(const char*);	// name search
	nsl_layer*	get_layer(const int);	// index search

// modules
	int get_module_total() { return module_total; }
	nsl_list* get_module_list() { return module_list; }

	int	add_module(nsl_module*);

	nsl_module*	get_module();		// get first module
	nsl_module*	get_module(const char*);// name search
	nsl_module*	get_module(const int);	// index search

	virtual int init();

	virtual int run();
	int run(const int,const int);
	int run(const float,const float);

// header for output data file
	void file_header(ostream&);

// print
	virtual int 	print(ostream&) const;
	int 	print_model(ostream&) const;
	virtual int 	print_status(ostream&) const;
	int 	print_model_status(ostream&) const;

	virtual int 	print_all(ostream&) const;
	int 	print_model_all(ostream&) const;
	virtual int 	print_all_status(ostream&) const;
	int 	print_model_all_status(ostream&) const;

	int 	write_model(nsl_buffer&);
	virtual int 	write(nsl_buffer&);
	int 	read_model(nsl_buffer&);
	virtual int 	read(nsl_buffer&);
};

