/* SCCS  @(#)nsl_system.h	1.1---95/08/13--23:37:23 */
//
// 	nsl_system.h
//

class nsl_system : public nsl_public
{
// current pointer
	on_off_enum xsystem_fg;		// ON - Window interface
//	nsl_interpreter* INTERPRETER;	// interpreter
 
	int model_total; 		// total number of models
	nsl_list* model_list; 		// pointer to all models

	int proc_total; 		// total number of system procs
	nsl_list* proc_list; 		// pointer to all system procs

	int diff_method_total; 		// total number of diff methods
	nsl_list* diff_method_list; 	// pointer to all diff methods

	int diff_model_total; 		// total number of diff models
	nsl_list* diff_model_list; 	// pointer to all diff models

	int thresh_lib_total; 		// total number of thresh libraries
	nsl_list* thresh_lib_list; 	// pointer to all thresh libraries

// i/o files
	nsl_string nsl_dir;		// nsl system directory
 
	int file_type_total; 		// total number of file types
	nsl_list* file_type_list;   	// pointer to file list types

	nsl_file_manager* fm;		// file manager

// cmds
	nsl_cmd_system* sys;		// cmd_system root

 // system
	int* argc_ptr;
	char** argv_ptr;
	
public:
		nsl_system();
		virtual ~nsl_system();

	void		set_xsystem_fg(on_off_enum fg) { xsystem_fg = fg; }
	on_off_enum	get_xsystem_fg() { return xsystem_fg; }

// model
	int 	get_model_total() { return model_total; }
	nsl_list* get_model_list() { return model_list; }

	int		add_model(nsl_model*);
	nsl_model*	get_model(const char*);		// name search
	nsl_model*	get_model(const int);		// index search

	void		set_model(nsl_model* m) { set_ptr((nsl_base*)m); }
	nsl_model*	get_model() { return (nsl_model*) get_ptr(); } 

// procedure
	int 	get_proc_total() { return proc_total; }
	nsl_list* get_proc_list() { return proc_list; }

	int		insert_proc(nsl_module*);
	int		add_proc(nsl_module*);
	nsl_module*	get_proc(const char*);		// name search
	nsl_module*	get_proc(const int);		// index search

	int 		init();
	int 		init_proc();

// diff method
	int 	get_diff_method_total() { return diff_method_total; }
	nsl_list* get_diff_method_list() { return diff_method_list; }

	int		add_diff_method(nsl_diff_method*);
	nsl_diff_method*	get_diff_method(const char*);

// diff model
	int 	get_diff_model_total() { return diff_model_total; }
	nsl_list* get_diff_model_list() { return diff_model_list; }

	int		add_diff_model(nsl_diff*);
	nsl_diff*	get_diff_model(const char*); // nsl_diff_model

// thresh
	int 	get_thresh_lib_total() { return thresh_lib_total; }
	nsl_list* get_thresh_lib_list() { return thresh_lib_list; }

	int		add_thresh_lib(nsl_thresh_library*);
	nsl_thresh_library*	get_thresh_lib(const char*);

// interpreter
//	void		set_interpreter(nsl_interpreter* m) { NSL = m; }
//	nsl_interpreter* get_interpreter() { return NSL; } 

// i/o file
	char* 	get_nsl_dir() { return nsl_dir; }
 
	int 	get_file_type_total() { return file_type_total; }
	nsl_list* get_file_type_list() { return file_type_list; }

	int		add_file_type(nsl_file*);
	nsl_file*	get_file_type(const char*);	// name search
	nsl_file*	get_file_type(const int);	// index search

	nsl_file_manager* get_file_manager() { return fm; }

// cmds
	nsl_cmd_system* get_cmd_system() { return sys; }
	void set_cmd_system(nsl_cmd_system* s) { sys = s; }

// system
	void set_argc_ptr(int* ptr) { argc_ptr = ptr; }
	int* get_argc_ptr() { return argc_ptr; }
	void set_argv_ptr(char** ptr) { argv_ptr = ptr; }
	char** get_argv_ptr() { return argv_ptr; }

// print status
	int	init_system();

	virtual int 	print(ostream&) const;
	int 	print_system(ostream&) const;
	virtual int 	print_status(ostream&) const;
	int 	print_system_status(ostream&) const;

	virtual int 	print_all(ostream&) const;
	int 	print_system_all(ostream&) const;
	virtual int 	print_all_status(ostream&) const;
	int 	print_system_all_status(ostream&) const;

	int 	write_system(nsl_buffer&);
	virtual int 	write(nsl_buffer&);
	int 	read_system(nsl_buffer&);
	virtual int 	read(nsl_buffer&);
};
