/* SCCS  @(#)nsl_layer.C	1.1---95/10/13--16:37:10 */
//
//	nsl_layer.C
//

# include "kallincl.h"

// nsl_public(rfg = 1) - avoid recursion on nsl_base::init_base

nsl_layer::nsl_layer(int rfg) : nsl_public(rfg) 
{
	init_layer("layer","");
}
nsl_layer::nsl_layer(const char* ltype,const char* lname,int fg,int rfg) : 
	nsl_public(rfg)
{
	init_layer(ltype,lname);

	if (fg == 1 || fg == 2) // aw: added option 2 for interpreter
	{
	   if ((m_parent = (nsl_model*) SYSTEM->get_model()) != NULL)
		((nsl_model*) m_parent)->add_layer(this); 
	   else
		cmd_error("NSL LAYER: Null Manager Parent");

	   if (fg == 2)
		NSL.add_object(this);
	}
}
nsl_layer::~nsl_layer()
{
}
int nsl_layer::get_size(int i) 
{ 
	if ((i >= 0) && (i < size_fg))
		return size[i]; 
	else
	{
		cmd_error("nsl_layer::get_size: BAD size: ",i);
		return 0;
	}
}

// init

int nsl_layer::init_layer(const char* ltype,const char* lname)
{
	if (SYSTEM == NULL)
	{
		SYSTEM = new nsl_system;
		cmd_out("nsl_layer:Initializing SYSTEM...");
	}

	layer_type = 0; // basic layer
	set_type(ltype);
	set_name(lname);
	set_base_type("layer");

	value_fg = 0;
	region_fg = 0;

	return 1;
}

// run

int nsl_layer::run()
{
	return 1;
}

// print

int nsl_layer::print_layer_status(ostream& out) const
{
	print_base(out);
	out <<  "// layer_type:\t\t" << layer_type << "\n";
	out.flush();

	return 1;
}
int nsl_layer::print_status(ostream& out)  const // virtual
{
	print_layer_status(out);
	return 1;
}
int nsl_layer::print_layer(ostream& out) const
{
	out <<  "\nassign layer " << get_name() << "\n";
	out.flush();
	return 1;
}
int nsl_layer::print(ostream& out) const // virtual
{
	print_layer(out);
	return 1;
}

int nsl_layer::reset_layer(nsl_buffer*)
{
	return 1;
}
int nsl_layer::reset(nsl_buffer* buf)
{
	reset_layer(buf);
	return 1;
}

int nsl_layer::write_layer(nsl_buffer&)
{
	return 1;
}
int nsl_layer::write(nsl_buffer& buf)
{
	write_layer(buf);
	return 1;
}
int nsl_layer::read_layer(nsl_buffer&)
{
	return 1;
}
int nsl_layer::read(nsl_buffer& buf)
{
	read_layer(buf);
	return 1;
}

