/* SCCS  @(#)nsl_diff_euler_data.C	1.1---95/10/13--16:37:20 */
//
// nsl_diff_euler_data.C
//

# include "kallincl.h"

nsl_diff_euler_data::nsl_diff_euler_data()
{
	init_diff_euler_data();
}
nsl_diff_euler_data::~nsl_diff_euler_data()
{
}

int nsl_diff_euler_data::init_diff_euler_data()
{
	set_type("euler_data"); // num_data
 
	return 1;
}

int nsl_diff_euler_data::exec(const num_type a)
{
	*((nsl_data*) layer) = *((nsl_data*) layer) + p*a;

	return 1;
}
int nsl_diff_euler_data::exec(const nsl_num_data& a)
{
	*((nsl_data*) layer) = *((nsl_data*) layer) + p*a;

	return 1;
}
int nsl_diff_euler_data::exec(const nsl_num_vector&)
{
	cmd_error("nsl_diff_euler_data: Bad vector to data conversion");

	return 1;
}
int nsl_diff_euler_data::exec(const nsl_num_matrix&)
{
	cmd_error("nsl_diff_euler_data: Bad vector to data conversion");

	return 1;
}

extern void NSLmult_equal(nsl_num_data&,const nsl_num_data&,const num_type&);
extern void NSLmult_plus(nsl_num_data&,const nsl_num_data&,const num_type&);

int nsl_diff_euler_data::run(nsl_layer* out,nsl_layer* in)
{
	num_type p0 = dt/tm;
	num_type p1 = 1.0 - dt/tm;
	
	// m(t+dt) = (1-dt/tm)*m(t) + (dt/tm)*Sm
NSLmult_equal(*((nsl_num_data*) out), *((nsl_num_data*) out), p1);
NSLmult_plus(*((nsl_num_data*) out), *((nsl_num_data*) in), p0);

	return 1;
}

nsl_diff_method* nsl_diff_euler_data::make_copy()
{
	return new nsl_diff_euler_data;
}
