/* SCCS  @(#)nsl_diff_euler_matrix.C	1.1---95/10/13--16:37:20 */
//
// nsl_diff_euler_matrix.C
//

# include "kallincl.h"

nsl_diff_euler_matrix::nsl_diff_euler_matrix()
{
	init_diff_euler_matrix();
}
nsl_diff_euler_matrix::~nsl_diff_euler_matrix()
{
}

int nsl_diff_euler_matrix::init_diff_euler_matrix()
{
	set_type("euler_matrix"); // num_matrix
 
	return 1;
}

int nsl_diff_euler_matrix::exec(const num_type a)
{
	*((nsl_matrix*) layer) = *((nsl_matrix*) layer) + p*a;

	return 1;
}
int nsl_diff_euler_matrix::exec(const nsl_num_data& a)
{
	*((nsl_matrix*) layer) = *((nsl_matrix*) layer) + p*a;

	return 1;
}
int nsl_diff_euler_matrix::exec(const nsl_num_vector&)
{
	cmd_error("nsl_diff_euler_vector: Bad vector to matrix conversion");

	return 1;
}
int nsl_diff_euler_matrix::exec(const nsl_num_matrix& a)
{
	*((nsl_matrix*) layer) = *((nsl_matrix*) layer) + p*a;

	return 1;
}

extern void NSLmult_equal(nsl_num_matrix&,const nsl_num_matrix&, 
const num_type&);
extern void NSLmult_plus(nsl_num_matrix&,const nsl_num_matrix&, 
const num_type&);

int nsl_diff_euler_matrix::run(nsl_layer* out,nsl_layer* in)
{
	num_type p0 = dt/tm;
	num_type p1 = 1.0 - dt/tm;
	
	// m(t+dt) = (1-dt/tm)*m(t) + (dt/tm)*Sm
NSLmult_equal(*((nsl_num_matrix*) out), *((nsl_num_matrix*) out), p1);
NSLmult_plus(*((nsl_num_matrix*) out), *((nsl_num_matrix*) in), p0);

	return 1;
}

nsl_diff_method* nsl_diff_euler_matrix::make_copy()
{
	return new nsl_diff_euler_matrix;
}
