/* SCCS  @(#)nsl_mat_to_vec_library.C	1.1---95/08/13--20:48:17 */
//
//	nsl_mat_to_vec_library.C
//

# include "kallincl.h"

nsl_vector NSLmat_to_vec(const nsl_vector& ref,const nsl_matrix& a)
{
	int vec_type = ref.get_vec_type();

	int simax = a.get_imax();
	int sjmax = a.get_jmax();

	int s = ref.get_imax();

	nsl_vector c(s);
	num_type* cv = c.get_vector();
	num_type** av = a.get_matrix();
	
	if (vec_type == 0) // row vector
	{
	    for (int i = 0; i < simax; i++)
	    	for (int j = 0; j < sjmax; j++)
		    cv[j] = av[i][j] + cv[j];
	}
	if (vec_type == 1) // col vector
	{
	    for (int i = 0; i < simax; i++)
	    	for (int j = 0; j < sjmax; j++)
		    cv[i] = av[i][j] + cv[i];
	}

	return c;
}

nsl_vector NSLmat_to_row_vec(const nsl_vector&,const nsl_matrix& a) 
{
	int simax = a.get_imax();
	int sjmax = a.get_jmax();

	nsl_vector c(sjmax);
	num_type* cv = c.get_vector();
	num_type** av = a.get_matrix();
		
	for (int i = 0; i < simax; i++)
	   for (int j = 0; j < sjmax; j++)
		cv[j] = av[i][j] + cv[j];
	return c;
}
nsl_vector NSLmat_to_col_vec(const nsl_vector&,const nsl_matrix& a) 
{
	int simax = a.get_imax();
	int sjmax = a.get_jmax();

	nsl_vector c(simax);
	num_type* cv = c.get_vector();
	num_type** av = a.get_matrix();
	
	for (int j = 0; j < sjmax; j++)
	    for (int i = 0; i < simax; i++)
		cv[i] = av[i][j] + cv[i];

	return c;
}

nsl_vector NSLmat_to_row_vec(const nsl_matrix& a)
{
	int simax = a.get_imax();
	int sjmax = a.get_jmax();
	num_type** av = a.get_matrix();

	nsl_vector c(sjmax);
	num_type* cv = c.get_vector();
		
	for (int i = 0; i < simax; i++)
	   for (int j = 0; j < sjmax; j++)
		cv[j] = av[i][j] + cv[j];
	return c;
}
nsl_vector NSLmat_to_col_vec(const nsl_matrix& a)
{
	int simax = a.get_imax();
	int sjmax = a.get_jmax();
	num_type** av = a.get_matrix();

	nsl_vector c(simax);
	num_type* cv = c.get_vector();
	
	for (int j = 0; j < sjmax; j++)
	    for (int i = 0; i < simax; i++)
		cv[i] = av[i][j] + cv[i];
	return c;
}

