/* SCCS  @(#)nsl_matrix_max_library.C	1.1---95/08/13--20:48:17 */
//
//	nsl_matrix_max_library.C
//

# include "kallincl.h"

num_type NSLmax(const nsl_matrix& a) 
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();

	num_type c = 0;
	num_type** av = a.get_matrix();

	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (av[i][j] > c)
			c = av[i][j];
	return c;
}

// if a > b then a else b

nsl_matrix NSLmax(const nsl_matrix& a,const nsl_matrix& b)
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();
	nsl_matrix c(s1,s2);

	if (a.get_imax() != b.get_imax() || a.get_jmax() != b.get_jmax())
	{
		cmd_error("*** NSLsat ***");
		cmd_error("Exit with the following status");
		cmd_error("imax1: ",a.get_imax());
		cmd_error("jmax1: ",a.get_jmax());
		cmd_error("imax2: ",b.get_imax());
		cmd_error("jmax2: ",b.get_jmax());
		cmd_error("bad matrix sector");
		return c;
	}

	num_type** av = a.get_matrix();
	num_type** cv = c.get_matrix();
	num_type** bv = b.get_matrix();
	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (av[i][j] > bv[i][j])
			cv[i][j] = av[i][j];
		else
			cv[i][j] = bv[i][j];
	return c;
}
nsl_matrix NSLmax(const nsl_matrix& a,const nsl_data& b)
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();
	nsl_matrix c(s1,s2);
	num_type bv = b.get_data();
	num_type** av = a.get_matrix();
	num_type** cv = c.get_matrix();
	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (av[i][j] > bv)
			cv[i][j] = av[i][j];
		else
			cv[i][j] = bv;
	return c;
}
nsl_matrix NSLmax(const nsl_matrix& a,const num_type b)
{
	int s1 = a.get_imax();
	int s2 = a.get_jmax();
	nsl_matrix c(s1,s2);
	num_type** av = a.get_matrix();
	num_type** cv = c.get_matrix();
	for (int i = 0; i < s1; i++)
	   for (int j = 0; j < s2; j++)
		if (av[i][j] > b)
			cv[i][j] = av[i][j];
		else
			cv[i][j] = b;
	return c;
}
