/* SCCS  @(#)nsl_vec_to_mat_library.C	1.1---95/08/13--20:48:17 */
//
//	nsl_vec_to_mat_library.C
//

# include "kallincl.h"

nsl_matrix NSLvec_to_mat(const nsl_matrix& ref,const nsl_vector& a)
{
	int vec_type = a.get_vec_type();

	int simax = ref.get_imax();
	int sjmax = ref.get_jmax();

	int s = a.get_imax();

	nsl_matrix c(simax,sjmax);
	num_type* av = a.get_vector();
	num_type** cv = c.get_matrix();
	
	if (vec_type == 0) // row vector
	{
	    if (s != sjmax)
	    {
		cmd_error("*** NSLvec_to_mat ***");
		cmd_error("vector jmax: ",s);
		cmd_error("matrix jmax: ",sjmax);
		cmd_error("Bad vector size");
		return c;
	    }

	    for (int i = 0; i < simax; i++)
	    	for (int j = 0; j < sjmax; j++)
		    cv[i][j] = av[j];
	}
	if (vec_type == 1) // col vector
	{
	    if (s != simax)
	    {
		cmd_error("*** NSLvec_to_mat ***");
		cmd_error("vector imax: ",s);
		cmd_error("matrix imax: ",simax);
		cmd_error("Bad vector size");
		return c;
	    }

	    for (int i = 0; i < simax; i++)
	    	for (int j = 0; j < sjmax; j++)
		    cv[i][j] = av[i];
	}

	return c;
}

nsl_matrix NSLrow_vec_to_mat(const nsl_matrix& ref,const nsl_vector& a)
{
	int simax = ref.get_imax();
	int sjmax = ref.get_jmax();

	int s = a.get_imax();

	nsl_matrix c(simax,sjmax);

	if (s != sjmax)
	{
		cmd_error("*** NSLrow_vec_to_mat ***");
		cmd_error("vector jmax: ",s);
		cmd_error("matrix jmax: ",sjmax);
		cmd_error("Bad vector size");
		return c;
	}

	num_type* av = a.get_vector();
	num_type** cv = c.get_matrix();
	
	for (int i = 0; i < simax; i++)
	    for (int j = 0; j < sjmax; j++)
		cv[i][j] = av[j];
	return c;
}

nsl_matrix NSLcol_vec_to_mat(const nsl_matrix& ref,const nsl_vector& a)
{ 
	int simax = ref.get_imax();
	int sjmax = ref.get_jmax();

	int s = a.get_imax();

	nsl_matrix c(simax,sjmax);

	if (s != simax)
	{
		cmd_error("*** NSLcol_vec_to_mat ***");
		cmd_error("vector imax: ",s);
		cmd_error("matrix imax: ",simax);
		cmd_error("Bad vector size");
		return c;
	}

	num_type* av = a.get_vector();
	num_type** cv = c.get_matrix();
	
	for (int i = 0; i < simax; i++)
	    for (int j = 0; j < sjmax; j++)
		cv[i][j] = av[i];
	return c; 
}

nsl_matrix NSLrow_vec_to_mat(const nsl_vector& a,const int simax)
{
	int sjmax = a.get_imax();
	num_type* av = a.get_vector();

	nsl_matrix c(simax,sjmax);
	num_type** cv = c.get_matrix();

	for (int i = 0; i < simax; i++)
	    for (int j = 0; j < sjmax; j++)
		cv[i][j] = av[j];
	return c;
}

nsl_matrix NSLcol_vec_to_mat(const nsl_vector& a,const int sjmax)
{
	int simax = a.get_imax();
	num_type* av = a.get_vector();

	nsl_matrix c(simax,sjmax);
	num_type** cv = c.get_matrix();
	
	for (int i = 0; i < simax; i++)
	    for (int j = 0; j < sjmax; j++)
		cv[i][j] = av[i];
	return c;
}
