/* SCCS  @(#)nsl_vector_comp_library.C	1.1---95/08/13--20:48:18 */
//
//	nsl_vector_comp_library.C
//

# include "kallincl.h"

// vector convolution

// comparator

int operator>(const nsl_vector& a, const num_type b)
{
	int aimax = a.get_imax();
	num_type *av = a.get_vector();

	for(int i = 0; i < aimax; i++)
		if(av[i] > b)
			return 1;
	return 0;
}

int operator<(const nsl_vector& a, const num_type b)
{
	int aimax = a.get_imax();
	num_type *av = a.get_vector();

	for(int i = 0; i < aimax; i++)
		if(av[i] < b)
			return 1;
	return 0;
}
int operator>(const num_type a, const nsl_vector& b)
{
	int aimax = b.get_imax();
	num_type *bv = b.get_vector();

	for(int i = 0; i < aimax; i++)
		if(a > bv[i])
			return 1;
	return 0;
}

int operator<(const num_type a, const nsl_vector& b)
{
	int aimax = b.get_imax();
	num_type *bv = b.get_vector();

	for(int i = 0; i < aimax; i++)
		if(a < bv[i])
			return 1;
	return 0;
}
int operator>(const nsl_vector& a, const nsl_data& b)
{
	int aimax = a.get_imax();
	num_type *av = a.get_vector();
	num_type bv = b.get_data();

	for(int i = 0; i < aimax; i++)
		if(av[i] > bv)
			return 1;
	return 0;
}

int operator<(const nsl_vector& a, const nsl_data& b)
{
	int aimax = a.get_imax();
	num_type *av = a.get_vector();
	num_type bv = b.get_data();

	for(int i = 0; i < aimax; i++)
		if(av[i] < bv)
			return 1;
	return 0;
}
int operator>(const nsl_data& a, const nsl_vector& b)
{
	int aimax = b.get_imax();
	num_type av = a.get_data();
	num_type *bv = b.get_vector();

	for(int i = 0; i < aimax; i++)
		if(av > bv[i])
			return 1;
	return 0;
}

int operator<(const nsl_data& a,const  nsl_vector& b)
{
	int aimax = b.get_imax();
	num_type av = a.get_data();
	num_type *bv = b.get_vector();

	for(int i = 0; i < aimax; i++)
		if(av < bv[i])
			return 1;
	return 0;
}

// >=, <=

int operator>=(const nsl_vector& a, const num_type b)
{
	int aimax = a.get_imax();
	num_type *av = a.get_vector();

	for(int i = 0; i < aimax; i++)
		if(av[i] >= b)
			return 1;
	return 0;
}

int operator<=(const nsl_vector& a, const num_type b)
{
	int aimax = a.get_imax();
	num_type *av = a.get_vector();

	for(int i = 0; i < aimax; i++)
		if(av[i] <= b)
			return 1;
	return 0;
}
int operator>=(const num_type a, const nsl_vector& b)
{
	int aimax = b.get_imax();
	num_type *bv = b.get_vector();

	for(int i = 0; i < aimax; i++)
		if(a >= bv[i])
			return 1;
	return 0;
}

int operator<=(const num_type a,const  nsl_vector& b)
{
	int aimax = b.get_imax();
	num_type *bv = b.get_vector();

	for(int i = 0; i < aimax; i++)
		if(a <= bv[i])
			return 1;
	return 0;
}
int operator>=(const nsl_vector& a, const nsl_data& b)
{
	int aimax = a.get_imax();
	num_type *av = a.get_vector();
	num_type bv = b.get_data();

	for(int i = 0; i < aimax; i++)
		if(av[i] >= bv)
			return 1;
	return 0;
}

int operator<=(const nsl_vector& a, const nsl_data& b)
{
	int aimax = a.get_imax();
	num_type *av = a.get_vector();
	num_type bv = b.get_data();

	for(int i = 0; i < aimax; i++)
		if(av[i] <= bv)
			return 1;
	return 0;
}
int operator>=(const nsl_data& a, const nsl_vector& b)
{
	int aimax = b.get_imax();
	num_type av = a.get_data();
	num_type *bv = b.get_vector();

	for(int i = 0; i < aimax; i++)
		if(av >= bv[i])
			return 1;
	return 0;
}

int operator<=(const nsl_data& a, const nsl_vector& b)
{
	int aimax = b.get_imax();
	num_type av = a.get_data();
	num_type *bv = b.get_vector();

	for(int i = 0; i < aimax; i++)
		if(av <= bv[i])
			return 1;
	return 0;
}

// ==, !=

int operator==(const nsl_vector& a, const num_type b)
{
	int aimax = a.get_imax();
	num_type *av = a.get_vector();

	for(int i = 0; i < aimax; i++)
		if(av[i] == b)
			return 1;
	return 0;
}

int operator!=(const nsl_vector& a,const  num_type b)
{
	int aimax = a.get_imax();
	num_type *av = a.get_vector();

	for(int i = 0; i < aimax; i++)
		if(av[i] != b)
			return 1;
	return 0;
}
int operator==(const num_type a,const  nsl_vector& b)
{
	int aimax = b.get_imax();
	num_type *bv = b.get_vector();

	for(int i = 0; i < aimax; i++)
		if(a == bv[i])
			return 1;
	return 0;
}

int operator!=(const num_type a, const nsl_vector& b)
{
	int aimax = b.get_imax();
	num_type *bv = b.get_vector();

	for(int i = 0; i < aimax; i++)
		if(a != bv[i])
			return 1;
	return 0;
}
int operator==(const nsl_vector& a, const nsl_data& b)
{
	int aimax = a.get_imax();
	num_type *av = a.get_vector();
	num_type bv = b.get_data();

	for(int i = 0; i < aimax; i++)
		if(av[i] == bv)
			return 1;
	return 0;
}

int operator!=(const nsl_vector& a, const nsl_data& b)
{
	int aimax = a.get_imax();
	num_type *av = a.get_vector();
	num_type bv = b.get_data();

	for(int i = 0; i < aimax; i++)
		if(av[i] != bv)
			return 1;
	return 0;
}
int operator==(const nsl_data& a, const nsl_vector& b)
{
	int aimax = b.get_imax();
	num_type av = a.get_data();
	num_type *bv = b.get_vector();

	for(int i = 0; i < aimax; i++)
		if(av == bv[i])
			return 1;
	return 0;
}

int operator!=(const nsl_data& a, const nsl_vector& b)
{
	int aimax = b.get_imax();
	num_type av = a.get_data();
	num_type *bv = b.get_vector();

	for(int i = 0; i < aimax; i++)
		if(av != bv[i])
			return 1;
	return 0;
}
