/* SCCS  @(#)nsl_vector_min_library.C	1.1---95/08/13--20:48:24 */
//
//	nsl_vector_min_library.C
//

# include "kallincl.h"

num_type NSLmin(const nsl_vector& a) 
{
	int s1 = a.get_imax();

	num_type* av = a.get_vector();

	num_type c = 0;

	for (int i = 0; i < s1; i++)
		if (av[i] < c)
			c = av[i];

	return c;
}

// if a < b then a else b

nsl_vector NSLmin(const nsl_vector& a,const nsl_vector& b)
{
	int s1 = a.get_imax();
	nsl_vector c(s1);

	if (a.get_imax() != b.get_imax())
	{
		cmd_error("*** NSLsat ***");
		cmd_error("Exit with the following status");
		cmd_error("imax1: ",a.get_imax());
		cmd_error("imax2: ",b.get_imax());
		cmd_error("bad vector sector");
		return c;
	}

	num_type* av = a.get_vector();
	num_type* bv = b.get_vector();
	num_type* cv = c.get_vector();

	for (int i = 0; i < s1; i++)
		if (av[i] < bv[i])
			cv[i] = av[i];
		else
			cv[i] = bv[i];
	return c;
}
nsl_vector NSLmin(const nsl_vector& a,const nsl_data& b)
{
	int s1 = a.get_imax();
	nsl_vector c(s1);

	num_type* av = a.get_vector();
	num_type bv = b.get_data();
	num_type* cv = c.get_vector();

	for (int i = 0; i < s1; i++)
		if (av[i] < bv)
			cv[i] = av[i];
		else
			cv[i] = bv;
	return c;
}
nsl_vector NSLmin(const nsl_vector& a,const num_type b)
{
	int s1 = a.get_imax();
	nsl_vector c(s1);

	num_type* av = a.get_vector();
	num_type* cv = c.get_vector();

	for (int i = 0; i < s1; i++)
		if (av[i] < b)
			cv[i] = av[i];
		else
			cv[i] = b;
	return c;
}
