/* SCCS  @(#)nsl_data_sat_library.C	1.1---95/08/13--20:48:14 */
//
//	nsl_data_sat_library.C
//

# include "kallincl.h"

nsl_data NSLsat(const nsl_data& a)
{
	nsl_data c;
	if (a > 1.0)
		c = 1.0;
	else if (a > 0)
		c = a;
	else
		c = 0;
	return c;
}
nsl_data NSLsat(const nsl_data& a,const num_type x1,const num_type x2)
{
	nsl_data c;
	if (a > x2)
		c = 1.0;
	else if (a > x1)
		c = (a-x1)/(x2-x1);
	else
		c = 0;
	return c;
}
nsl_data NSLsat(const nsl_data& a,const nsl_data& x1,const nsl_data& x2)
{
	nsl_data c;
	if (a > x2)
		c = 1.0;
	else if (a > x1)
		c = (a-x1)/(x2-x1);
	else
		c = 0;
	return c;
}
nsl_data NSLsat(const nsl_data& a,const num_type x1,
	const num_type x2,const num_type y1,const num_type y2)
{
	nsl_data c;
	if (a > x2)
	    c = y2;
	else if (a > x1)
	    c = (y2-y1)*(a-x1)/(x2-x1) + y1;
	else
	    c = y1;
	return c;
}
nsl_data NSLsat(const nsl_data& a,const nsl_data& x1,
	const nsl_data& x2,const nsl_data& y1,const nsl_data& y2)
{
	nsl_data c;
	if (a > x2)
	    c = y2;
	else if (a > x1)
	    c = (y2-y1)*(a-x1)/(x2-x1) + y1;
	else
	    c = y1;
	return c;
}
