/* SCCS  @(#)xnsl_area_level_graph_vector.C	1.1---96/02/20--19:21:53 */
//
//	xnsl_area_level_graph_vector.C
//

# include "kallincl.h"
# include "xallincl.h"

xnsl_area_level_graph_vector::xnsl_area_level_graph_vector(
	xnsl_display_canvas* win,
	nsl_vector* m) : xnsl_area_level_graph(win)
{
        set_type("area_level_graph_vector");

	init_area_level_graph_vector(m);

}
xnsl_area_level_graph_vector::~xnsl_area_level_graph_vector()
{
}

xnsl_widget * xnsl_area_level_graph_vector::make_widget ()
{
        return new xnsl_area_level_graph_vector;
//		((xnsl_display_canvas*) m_parent,
//		(nsl_vector*) _layer);
}

int xnsl_area_level_graph_vector::init_area_level_graph_vector(nsl_layer* m)
{
	if (m != NULL)
	{
		_layer = m;
		_imax = ((nsl_vector*) _layer)->get_imax();
		_layer0 = new nsl_vector(_imax);
		_i0 = 0;
		_i1 = _imax - 1;
		_vec_type = NSL_ROW;
 	}
//	else
//		cmd_error("xnsl_area_level_graph_vec: NULL layer");

	return 1;
}
int xnsl_area_level_graph_vector::clear()
{
  	num_type* m0 = ((nsl_vector*) _layer0)->get_vector();

	for (int i = 0; i < _imax; i++)
		m0[i] = 0;

	return 1;
}

int xnsl_area_level_graph_vector::display()
{
	set_env("",_X0,_Y0,_width,_height,_wx0,_wy0,_wx1,_wy1,_wxs,_wys);
 
	return 1;
}
int xnsl_area_level_graph_vector::display_area_level_graph(
	int wx0,int wy0,int wxs,int wys,
	num_type wymin, num_type wymax) 
{
	int fg; // redraw fg
	int i,ni;
	num_type val,val0;

  	num_type* m0 = ((nsl_vector*) _layer0)->get_vector();
	num_type* m = ((nsl_vector*) _layer)->get_vector();

//	if ((fg = parent_canvas->get_redraw_fg()) == 1)
//		parent_canvas->set_redraw_fg(0);

 	if (_vec_type == NSL_ROW)
	    for (i = wx0, ni = _i0; ni <= _i1; i = i + wxs, ni++)
	    {
		val = m[ni];
	     	val0 = m0[ni];
		if (val != val0 /*|| fg == 1*/) // new different values only
		{
//	 	    if (val < val0 || val < 0)
//			clear_area_level(i,wy0,wxs,wys);
		    display_area_level_graph_val(i,wy0,wxs,wys,
				val,wymin,wymax);
		}
	    }
	else
	    for (i = wy0, ni = _i0; ni <= _i1; i = i + wys, ni++)
	    {
		val = m[ni];
	     	val0 = m[ni];
		if (val != val0 || fg == 1) // new different values only
		{
//	 	    if (val < val0 || val < 0)
//			clear_area_level(wx0,i,wxs,wys);
		    display_area_level_graph_val(wx0,i,wxs,wys,
				val,wymin,wymax);
		}
	    }

	for (i = 0; i < _imax; i++)
		m0[i] = m[i];

	return 1;
}

int xnsl_area_level_graph_vector::read_from_database()
{
	xnsl_area_level_graph::read_from_database(); // read in new win sector

	return 1;
}
int xnsl_area_level_graph_vector::write_to_database()
{
	xnsl_area_level_graph::write_to_database();

	return 1;
}
int xnsl_area_level_graph_vector::input(int x_pos,int y_pos,int fg)
{
/*	float val;
	int i,ni;

	num_type* m0 = ((nsl_vector*) layer0_ptr)->get_vector();
	num_type* m = ((nsl_vector*) layer_ptr)->get_vector();

	if (fg == 1)
	   val = 0.0;
	else
	   parent_window->get_general_data("val_in",&val);

	if (y_pos <= wy1 && y_pos >= wy0 && x_pos <= wx1 && x_pos >= wx0)
	{
	    if (vec_type == 0)
	    {
	       for (i = wx0, ni = i0 ; i + wxs <= x_pos; ni++, i = i + wxs);
    	       draw_xnsl_area_level_val(canvas,i,wy0,wxs,wys,val,wymin,wymax);
	    }
	    else
	    {
	    	for (i = wy0, ni = i0 ; i + wys <= y_pos; ni++, i = i + wys);
    	    	draw_xnsl_area_level_val(canvas,wx0,i,wxs,wys,val,wymin,wymax);
	    }
	    m0[ni] = val;
	    m[ni] = val;
	}
*/
	return 1;
}
int xnsl_area_level_graph_vector::output(int x_pos,int y_pos)
{
	return 1;
}

int xnsl_area_level_graph_vector::print(ostream& out) const
{
	xnsl_area_level_graph::print(out);

	return 1;
}

