/* SCCS  %W%---%E%--%U% */
//
//	xnsl_spatial_graph_2_vector.C
//

# include "kallincl.h"
# include "xallincl.h"

xnsl_spatial_graph_2_vector::xnsl_spatial_graph_2_vector(
	xnsl_display_canvas* win,
	nsl_vector* m) : xnsl_spatial_graph_2(win)
{
        set_type("spatial_graph_2_vector");

	if (m != NULL)
	{
		_layer = m;
		_layer0 = m;

		_imax = ((nsl_vector*) _layer)->get_imax();
		_i0 = 0;
		_i1 = _imax - 1;
		_vec_type = NSL_ROW;
 	}
//	else
//		cmd_error("xnsl_spatial_graph_2_vec: NULL layer");
}
xnsl_spatial_graph_2_vector::~xnsl_spatial_graph_2_vector()  
{
}
xnsl_widget * xnsl_spatial_graph_2_vector::make_widget()
{
        return new xnsl_spatial_graph_2_vector((xnsl_display_canvas*) m_parent,
		(nsl_vector*) _layer);
}
int xnsl_spatial_graph_2_vector::display()
{
	set_env("",_X0,_Y0,_width,_height,_wx0,_wy0,_wx1,_wy1,_wxs,_wys);
 
	return 1;
}
int xnsl_spatial_graph_2_vector::display_spatial_graph_2(
	int wx0,int wy0,int wx1,int wy1,int wxs,int wys,
	num_type wymin, num_type wymax) 
{
        if (_vec_type != NSL_ROW)
        {
                cmd_error("xnsl_spatial_graph_2_vec:Unable to draw col vector");
                return 1;
        }

	num_type* m = ((nsl_vector*) _layer)->get_vector();

        wys = 0;

        num_type x,y;
        int xp,yp,xc,yc;

        num_type fx0 = (num_type) _i0;
        num_type fx1 = (num_type) _i1;

        num_type u0 = (num_type) wx0;
        num_type u1 = (num_type) (wx1 - wx0);
        num_type v0 = (num_type) wy0;
        num_type v1 = (num_type) (wy1 - wy0);

        num_type fy0 = wymin;
        num_type fy1 = wymax;

        xp = wx0 + wxs/2;
        yp = coord_transform(m[_i0],fy0,fy1,v0,v1);

        draw_line(wx0,yp,xp,yp);

        for (int i = _i0; i <= _i1; i++)
        {
//              if (breakfg == 1)
//                  return(1);

                x = (num_type) i; 
                y = m[i];

                xc = wx0 + (i-_i0)*wxs + wxs/2;
                yc = coord_transform(y,fy0,fy1,v0,v1);
                if (pulsefg == 1)
                {
                        xp = wx0 + (i-_i0)*wxs;
                        xc = wx0 + (i-_i0+1)*wxs;
                        draw_line(xp,yp,xp,yc);
                        yp = yc;
                }
                draw_line(xp,yp,xc,yc);
                xp = xc;
                yp = yc;
        }
        draw_line(xp,yp,wx1,yp);

	return 1;
}

int xnsl_spatial_graph_2_vector::read_from_database()
{
/*	parent_window->get_general_data("i0",&i0);
	parent_window->get_general_data("i1",&i1);

	imax = ((nsl_vector*) layer_ptr)->get_imax();

	parent_window->get_general_data("vec_type",&vec_type);

	if (i0 < 0) 
	{
		i0 = 0;
		parent_window->set_general_data("i0",i0);
	}
	if (i1 > imax-1) 
	{
		i1 = imax-1;
		parent_window->set_general_data("i1",i1);
	}
	if (i1 < i0)
	{
		i0 = 0;
		i1 = imax-1;
		parent_window->set_general_data("i0",i0);
		parent_window->set_general_data("i1",i1);
	}

	if (vec_type == 0)
	   parent_window->set_win_sector(0,i0,0,i1,1,imax); // update win sector
	else
	   parent_window->set_win_sector(i0,0,i1,0,imax,1); // update win sector
	spatial_graph_2::read_from_database(); // read in new win sector
*/

	return 1;
}
int xnsl_spatial_graph_2_vector::write_to_database()
{
	xnsl_spatial_graph_2::write_to_database();

	return 1;
}
int xnsl_spatial_graph_2_vector::print(ostream& out) const
{
	xnsl_spatial_graph_2::print(out);

	return 1;
}

