/* SCCS  %W%---%E%--%U% */
//
//	xnsl_temporal_graph_vector.C
//

# include "kallincl.h"
# include "xallincl.h"

xnsl_temporal_graph_vector::xnsl_temporal_graph_vector(xnsl_display_canvas* win,
	nsl_vector* m) : xnsl_temporal_graph(win)
{
        set_type("temporal_graph_vector");

	if (m != NULL)
	{
		_layer = m;

		_imax = ((nsl_vector*) _layer)->get_imax();

		_layer0 = new nsl_vector(_imax);

		_i0 = 0;
		_i1 = _imax - 1;
		_vec_type = NSL_ROW;
 	}
//	else
//		cmd_error("xnsl_temporal_graph_vec: NULL layer");
}
xnsl_temporal_graph_vector::~xnsl_temporal_graph_vector()
{
}
xnsl_widget * xnsl_temporal_graph_vector::make_widget()
{
        return new xnsl_temporal_graph_vector((xnsl_display_canvas*) m_parent,
		(nsl_vector*) _layer);
}
int xnsl_temporal_graph_vector::display()
{
	set_env("",_X0,_Y0,_width,_height,_wx0,_wy0,_wx1,_wy1,_wxs,_wys);
 
	return 1;
}
int xnsl_temporal_graph_vector::display_temporal_graph(
	int wx0,int wy0,int wx1,int wy1,int wxs,int wys,
	num_type wymin, num_type wymax) 
{
	nsl_model* model;

	if ((model = SYSTEM->get_model()) == NULL)
	{
		cmd_error("NULL MODEL");
		return 1;
	}

	float ts = model->get_time();
	float dt = model->get_delta();

	num_type* m0 = ((nsl_vector*) _layer0)->get_vector();
	num_type* m = ((nsl_vector*) _layer)->get_vector();

//	draw_temporal_graph_vector(canvas,m,m0,
// 		wx0,wy0,wxs,wys,i0,i1,wymin,wymax,t0,t1,ts,dt,pulsefg,vec_type);

        if (_vec_type != NSL_ROW)
        {
                cmd_error("Unable to draw col vector");
                return 1;
        }

        int ux0,uy0;
        num_type u0,u1,v0,v1;
        num_type x,y;
        int xc,yc,xp,yp;

        num_type fx0 = _t0;
        num_type fx1 = _t1;

        num_type fy0 = wymin;
        num_type fy1 = wymax;

        for (int i = _i0; i <= _i1; i++)
        {
//              if (breakfg == 1)
//                  return(1);

                if (ts >= 0.0)
                {
                    ux0 = wx0 + (i-_i0)*wxs;
                    uy0 = wy0;

                    u0 = (num_type) ux0;
                    u1 = (num_type) wxs;
                    v0 = (num_type) uy0;
                    v1 = (num_type) wys;

                    x = ts; 
                    y = m[i];
                    xc = coord_transform(x,fx0,fx1,u0,u1);
                    yc = coord_transform(y,fy0,fy1,v0,v1);
                    if (ts == 0.0)
                    {
                        xp = coord_transform(x,fx0,fx1,u0,u1);
                        yp = coord_transform(y,fy0,fy1,v0,v1);
                    }
                    else
                    {
                        x = ts-dt;
                        y = m0[i];
                        xp = coord_transform(x,fx0,fx1,u0,u1);
                        yp = coord_transform(y,fy0,fy1,v0,v1);
                    }
                    if (pulsefg == 1)
                    {
                        draw_line(xp,yp,xp,yc);
                        yp = yc;
                    }
                    draw_line(xp,yp,xc,yc);
                }
        }

	for (i = 0; i < _imax; i++)
		m0[i] = m[i];

	return 1;
}
int xnsl_temporal_graph_vector::read_from_database()
{
	return 1;
}
int xnsl_temporal_graph_vector::write_to_database()
{
	return 1;
}
int xnsl_temporal_graph_vector::print(ostream& out) const
{
	return 1;
}
 
