/* SCCS  %W%---%E%--%U% */
//////////////////////////////////////////////////////////////////////////
//
//xnsl_line.C:Class that creates a generic line
//
//////////////////////////////////////////////////////////////////////////

# include "kallincl.h"
# include "xallincl.h"

xnsl_line::xnsl_line(xnsl_display_canvas* win,float s0, float s1)
	: xnsl_graph(win)
{
	set_type("line");
	f0 = s0;
	f1 = s1;
	dir_type = 1;  // horizontal line
	line_type = 1; // broken line
}
xnsl_line::~xnsl_line()
{
}

xnsl_widget * xnsl_line::make_widget()
{
	return new xnsl_line;
}

xnsl_widget * xnsl_line::create_widget (const char *wname,
 	xnsl_widget * pxnsl_widget,int x,int y,int width,int height,
	int wx0, int wy0, int wx1, int wy1, int wx, int wy,
	const char* label,const char* message)
{
	xnsl_manager	*pxnsl_manager;
 
	strcpy(_wname,wname);
	_X0 = x;
	_Y0 = y;
	_width = width;
	_height = height;

	_wx0 = wx0;
	_wy0 = wy0;
	_wx1 = wx1;
	_wy1 = wy1;
	_wxs = wx;
	_wys = wy;

	if (pxnsl_widget == NULL)
	{
		cmd_error("line: NULL parent");
		return this;
	}

	pxnsl_manager = XSYSTEM->get_xnsl_manager();
	_pxnsl_lib_widget = (xnsl_lib_widget*) 
		pxnsl_manager->create_manager_widget(
			"graph", pxnsl_widget,wname,x,y,width,height,
			wx0,wy0,wx1,wy1,wx,wy,label,message);

 	if (_pxnsl_lib_widget == NULL )
		cerr << "create_line_widget failed.\n";
  
	return this;
} 

void xnsl_line::set_env(const char *,int x,int y,int width,int height,
	int wx0,int wy0,int wx1,int wy1,int wxs, int wys,
	const char*,const char*)
{
	if (wxs == 0 || wys == 0 || wx0 == wx1 || wy0 == wy1)
	{
		cmd_error("xnsl_line::display: Bad set of wx/wy values");
		return;
	}

//	draw_broken_line(canvas,x0,y0,x1,y1); // only one line
	nsl_string color;
	strcpy(color,"blue");

	num_type wymin = _wymin;
	num_type wymax = _wymax;

	int sx,wx;
	int sy,wy;

        int ys = 5;
        int ym = 3;

        int xs = 5;
        int xm = 3;

//	if (able_fg == 0 || redraw_fg == 0)
//		return;

	if (dir_type == 1) // horizontal, f0 = f1
	{
	  for (wy = wy0; wy <= wy1 - wys; wy = wy + wys)
	  {
      	    sy = coord_transform(f0,wymin,wymax,(float)wy,(float)wys);
	    if (sy > wy && sy < wy + wys)
	    {
//		if (line_type = 1) // broken 
  	        for (wx = wx0; wx < wx1 - xs; wx = wx + xs)
                	draw_line(wx,sy,wx+xs,sy,color);
        	draw_line(wx,sy,wx1,sy,color);
	    }
	  }
	}
	else if (dir_type == 2) // vertical, f0 = f1
	{
	  for (wx = wx0; wx <= wx1 - wxs; wx = wx + wxs)
	  {
  	    sx = coord_transform(f0,wymin,wymax,(float)wx,(float)wxs); 
	    if (sx > wx && sx < wx + wxs)
	    {
//		if (line_type = 1) // broken 
 	        for (wy = wy0; wy < wy1 - ys; wy = wy + ys)
                	draw_line(sx,wy,sx,wy+ys,color);
        	draw_line(sx,wy,sx,wy1,color);
	    }
	  }
	}
	else
	  cmd_error("xnsl_line::display: Unable to draw line");
} 

int xnsl_line::display()
{
        set_env("",_X0,_Y0,_width,_height,_wx0,_wy0,_wx1,_wy1,_wxs,_wys); 
	
	return 1;
}

