/* SCCS  @(#)xnsl_tcltk_graph.C	1.1---95/08/13--21:05:31 */
//
//	xnsl_tcltk_graph.C
//

# include "nsl_all_kernel_include.h"
# include "xnsl_all_xkernel_include.h"
# include "xnsl_tcltk_include.h"

extern int NSL_TK_FLUSH;
typedef char nsl_long_string[256];

xnsl_tcltk_graph::xnsl_tcltk_graph() : xnsl_tcltk_widget()
{
        set_type("graph");
        set_abstract_type("graph");
}
xnsl_tcltk_graph::~xnsl_tcltk_graph()
{
}
xnsl_widget* xnsl_tcltk_graph::make_widget()
{
	return new xnsl_tcltk_graph;
}

int xnsl_tcltk_graph::display()
{
	return 1;
}
int xnsl_tcltk_graph::xflush()
{
	if (NSL_TK_FLUSH == 1)
		Tcl_Eval(NSL_TCL_INTERP,"update idletasks");

	return 1;
}

int xnsl_tcltk_graph::clear_area(int wx0,int wy0,int wx1,int wy1)
{
//	(wx0,wy0) is lower left corner.
//	 wx1: width, wy1: height

	nsl_long_string str;
	char c = 'p';

	sprintf(str,"%s.canvas create rectangle %d%c %d%c %d%c %d%c -fill white -outline white" \
		,_wname,wx0,c,wy0,c,wx0+wx1,c,wy0+wy1,c);

	Tcl_Eval(NSL_TCL_INTERP,str);

	return 1;
}
int xnsl_tcltk_graph::fill_rectangle(int wx0,int wy0,int wx1,int wy1)
{
//	(wx0,wy0) is lower left corner.
//	 wx1: width, wy1: height

	nsl_long_string str;
	char c = 'p';

	sprintf(str,"%s.canvas create rectangle %d%c %d%c %d%c %d%c -fill black" \
		,_wname,wx0,c,wy0,c,wx0+wx1,c,wy0+wy1,c);

	Tcl_Eval(NSL_TCL_INTERP,str);

	return 1;
}
int xnsl_tcltk_graph::draw_line(int wx0,int wy0,int wx1,int wy1,
	const char* color)
{
	nsl_long_string str;
	nsl_string line_color;
	char c = 'p';
	if (color != 0 && strcmp(color,"") != 0) // color != "" 
		strcpy(line_color,color);
	else
		strcpy(line_color,"black");

	sprintf(str,"%s.canvas create line %d%c %d%c %d%c %d%c -fill %s",_wname,wx0,c,_height-wy0,c,wx1,c,_height-wy1,c,line_color);

	Tcl_Eval(NSL_TCL_INTERP,str);

	return 1;
}
int xnsl_tcltk_graph::draw_grid(int wx0,int wy0,int wx1,int wy1,
	num_type x0, num_type y0, num_type x1, num_type y1, 
	num_type xs, num_type ys)
{
	nsl_long_string str;
	
	char c = 'p';
	
	sprintf(str,"grid %s.canvas %d %d %d %d %f %f %f %f %f %f %c",_wname,
		wx0,wy0,wx1,wy1,x0,y0,x1,y1,xs,ys,c);

	Tcl_Eval(NSL_TCL_INTERP,str);

	return 1;
}
int xnsl_tcltk_graph::draw_text(int wx,int wy,const char* text)
{
	nsl_long_string str;
	char c = 'p';

	sprintf(str,"%s.canvas create text %d%c %d%c -text %s -anchor sw"	\
		,_wname,wx,c,_height-wy,c,text);

	Tcl_Eval(NSL_TCL_INTERP,str);

	return 1;
}

xnsl_widget* xnsl_tcltk_graph::create_widget(const char *wname,
	xnsl_widget* pxnsl_widget,int x,int y,int w,int h,
	int,int,int,int,int,int,const char*,const char*)
{
	strcpy(_wname,wname);
	_X0 = x;
	_Y0 = y;
	_width = w;
	_height = h;

	return this;
}

void xnsl_tcltk_graph::set_env(const char*,int,int,int,int,int,int,
	int,int,int,int,const char*,const char*)
{
}

int xnsl_tcltk_graph::print(ostream&) const
{
	return 1;
}


