# NSL2.8: dev.tcl
# AW - 3/96

create neural_network DEV 	;# model

assign DEV delta 0.1		;# simulation delta
assign DEV end_time 10.0 	;# simulation end_time

create neuron_matrix U 10 8
create neuron_vector V 8
create num_matrix S 10 8
create num_vector w1 5

connect U U w1 1	;# U <- + w1*U
connect U V -1		;# U <- - V
connect U S 1		;# U <- + S
connect V U 1		;# V <- + U

assign U diff_model leaky
assign U diff_method euler
assign U diff_delta 0.1 	
assign U thresh step 0.75 0 1	;# assign data_value k 0.75
assign U tm 1.0			;# assign data_value tm 1.0
assign U h 0.7			;# (U <- - h) assign data_value h 0.7
assign U inp -0.5 		;# -0.5 initial membrane potential value

assign V diff_model leaky
assign V diff_method euler
assign V diff_delta 0.1 	
assign V thresh ramp 0 0 0
assign V tm 1.0			;# assign data_value tm 1.0
assign V h 0.7			;# (U <- - h) assign data_value h 0.7

assign w1 value 0.4 0.6 1.0 0.6 0.4

assign S value 				\
-.5 -.5 -.5 -.5 -.5 -.5 -.5 -.5 	\
-.5 -.5 -.5 -.5 -.5 -.5 -.5 -.5 	\
-.5 -.5 -.5 -.5 1.5 -.5 -.5 -.5 	\
-.5 -.5 -.5 -.5 -.5 -.5 -.5 -.5 	\
-.5 -.5 1.5 -.5 1.5 -.5 -.5 -.5 	\
-.5 -.5 -.5 -.5 -.5 -.5 -.5 -.5		\
-.5 -.5 1.5 -.5 -.5 -.5 -.5 -.5 	\
-.5 -.5 -.5 -.5 -.5 -.5 -.5 -.5 	\
-.5 -.5 -.5 -.5 -.5 -.5 -.5 -.5 	\
-.5 -.5 -.5 -.5 -.5 -.5 -.5 -.5

create window_interface

# assign display_frame X0 250
# assign display_frame Y0 100
assign display_frame width 500
assign display_frame height 200
# assign display_frame rows 3
create display_frame .dev

assign display_window layer S
assign display_window graph area_level_graph 
assign display_window wymin -1
assign display_window wymax 2
create display_window .dev.s

assign display_window layer U_mp
assign display_window graph area_level_graph
assign display_window wymin -3
assign display_window wymax 3
create display_window .dev.u_mp

assign display_window layer U_out
assign display_window graph area_level_graph
assign display_window wymin -3
assign display_window wymax 3
create display_window .dev.u_out

