//
// 	generic_window.h
//

struct generic_window
{
	char name[NAME_SIZE];	// window name 
	int index;		// window index 
	int X0,Y0;		// upper left window location 
	int width;		// window width 
	int height;		// window height 
	int done_fg;		// 1 - dead, 0 - alive
	int able_fg;		// 1 - running, 0 -idle
public:
		generic_window(char*,int,int,int,int,int);
		~generic_window();

// set functions
	void	set_able_fg(int fg) { able_fg = fg; }
	void	set_name(char* str) { strcpy(name,str); }
	void	set_index(int i) { index=i; }
	void	set_X0(int x) { X0=x; }
	void	set_Y0(int y) { Y0=y; }
	void	set_width(int x) { width=x; }
	void	set_height(int y) { height=y; }
	void	set_done_fg(int i) { done_fg = i; }

// get functions
	int	get_able_fg() { return able_fg; }
	char*	get_name() { return name; }
	int	get_index() { return index; }
	int	get_X0() { return X0; }
	int	get_Y0() { return Y0; }
	int	get_width() { return width; }
	int	get_height() { return height; }
	int	get_done_fg() { return done_fg; }

	void 	enable() { able_fg = 1; }
	void 	disable() { able_fg = 0; }

// virtual window interface
	virtual	void print_status(ostream&);
	virtual	void create() {}
	virtual	void init() {}
	virtual	void clear() {}
	virtual	void refresh() {}
	virtual	void display() {}
	virtual	void display(char*) {}
};

typedef generic_window* gen_window_ptr;
declare(gslist,gen_window_ptr);

typedef gslist_iterator(gen_window_ptr) gen_window_iterator;
typedef gslist(gen_window_ptr) gen_window_list;
