//
//	nsl_data.h
//

extern class nsl_vector;
extern class nsl_matrix;
extern class nsl_model;

struct nsl_data : public nsl_layer
{
	int data_type;		// data type
	int flag;		// user defined
// union ??
	int ival;		// type = 1
	float v; // num_type	// type = 2
	char sval[NAME_SIZE];	// type = 3
public:
		nsl_data();
		nsl_data(nsl_data&);
		nsl_data(char*,int); // name & type

		nsl_data(nsl_model&,char*); 
		nsl_data(nsl_model*,char*);
		nsl_data(char*); // NSL_MODEL

		~nsl_data();

	void	set_flag(int i) { flag = i; }
	int 	get_flag() { return flag; }
	// get
	char*	get_name() { return name; }
	int 	get_data_type() { return data_type; }
	// get value
	num_type get_data() { return v; }
	num_type get_value() { return v; }

	int	get_int_value() { return ival; }
	float	get_float_value() { return v; }
	char*	get_str_value() { return sval; }
	// set
	void	set_name(char* str) { strcpy(name,str); }
	void	set_data_type(int i) { data_type = i; }
	// set value
	void	set_value(int);
	void	set_value(float);
	void	set_value(char*);

// element retrieval
	num_type& elem() { return v; }

// 	assignment
void 	operator=(nsl_data&);
void 	operator=(double);
void 	operator=(float);
void 	operator=(int);

// 	arithmetic

// addition
friend	nsl_data 	operator+(nsl_data&);
friend 	nsl_data 	operator+(nsl_data&,nsl_data&);
friend 	nsl_data 	operator+(nsl_data&,num_type);
friend 	nsl_data 	operator+(num_type,nsl_data&);
friend	nsl_vector 	operator+(nsl_data&,nsl_vector&);
friend	nsl_vector 	operator+(nsl_vector&,nsl_data&);
friend	nsl_matrix 	operator+(nsl_data&,nsl_matrix&);
friend	nsl_matrix 	operator+(nsl_matrix&,nsl_data&);

// subtraction
friend 	nsl_data 	operator-(nsl_data&);
friend 	nsl_data 	operator-(nsl_data&,nsl_data&);
friend	nsl_data 	operator-(nsl_data&,num_type);
friend	nsl_data 	operator-(num_type,nsl_data&);
friend	nsl_vector 	operator-(nsl_data&,nsl_vector&);
friend	nsl_vector 	operator-(nsl_vector&,nsl_data&);
friend	nsl_matrix 	operator-(nsl_data&,nsl_matrix&);
friend	nsl_matrix 	operator-(nsl_matrix&,nsl_data&);

// pointwise multiplication
friend	nsl_vector 	operator^(nsl_data&,nsl_vector&);
friend	nsl_vector 	operator^(nsl_vector&,nsl_data&);
friend	nsl_matrix 	operator^(nsl_data&,nsl_matrix&);
friend	nsl_matrix 	operator^(nsl_matrix&,nsl_data&);

// pointwise division
friend 	nsl_data 	operator/(nsl_data&,nsl_data&);
friend	nsl_data 	operator/(nsl_data&,num_type);
friend	nsl_data 	operator/(num_type,nsl_data&);
friend	nsl_vector 	operator/(nsl_data&,nsl_vector&);
friend	nsl_vector 	operator/(nsl_vector&,nsl_data&);
friend	nsl_matrix 	operator/(nsl_data&,nsl_matrix&);
friend	nsl_matrix 	operator/(nsl_matrix&,nsl_data&);

// convolution
friend 	nsl_data 	operator*(nsl_data&,nsl_data&);
friend	nsl_data 	operator*(nsl_data&,num_type);
friend	nsl_data 	operator*(num_type,nsl_data&);
friend	nsl_vector 	operator*(nsl_data&,nsl_vector&);
friend	nsl_vector 	operator*(nsl_vector&,nsl_data&);
friend	nsl_matrix 	operator*(nsl_data&,nsl_matrix&);
friend	nsl_matrix 	operator*(nsl_matrix&,nsl_data&);

//	threshold functions

// NSLstep
friend	nsl_data 	NSLstep(nsl_data&);
friend	nsl_data 	NSLstep(nsl_data&,num_type);
friend	nsl_data 	NSLstep(nsl_data&,nsl_data&);
friend	nsl_data 	NSLstep(nsl_data&,num_type,num_type,num_type);
friend	nsl_data 	NSLstep(nsl_data&,nsl_data&,nsl_data&,nsl_data&);
friend	nsl_vector 	NSLstep(nsl_vector&,nsl_data&);
friend	nsl_matrix 	NSLstep(nsl_matrix&,nsl_data&);
friend	nsl_vector 	NSLstep(nsl_vector&,nsl_vector&,nsl_data&,nsl_data&);
friend	nsl_matrix 	NSLstep(nsl_matrix&,nsl_matrix&,nsl_data&,nsl_data&);
friend	nsl_vector 	NSLstep(nsl_vector&,nsl_data&,nsl_data&,nsl_data&);
friend	nsl_matrix 	NSLstep(nsl_matrix&,nsl_data&,nsl_data&,nsl_data&);

// NSLramp
friend	nsl_data 	NSLramp(nsl_data&);
friend	nsl_data 	NSLramp(nsl_data&,num_type);
friend	nsl_data 	NSLramp(nsl_data&,nsl_data&);
friend	nsl_data 	NSLramp(nsl_data&,num_type,num_type,num_type);
friend	nsl_data 	NSLramp(nsl_data&,nsl_data&,nsl_data&,nsl_data&);
friend	nsl_vector 	NSLramp(nsl_vector&,nsl_data&);
friend	nsl_matrix 	NSLramp(nsl_matrix&,nsl_data&);
friend	nsl_vector 	NSLramp(nsl_vector&,nsl_vector&,nsl_data&,nsl_data&);
friend	nsl_matrix 	NSLramp(nsl_matrix&,nsl_matrix&,nsl_data&,nsl_data&);
friend	nsl_vector 	NSLramp(nsl_vector&,nsl_data&,nsl_data&,nsl_data&);
friend	nsl_matrix 	NSLramp(nsl_matrix&,nsl_data&,nsl_data&,nsl_data&);

// NSLsat
friend	nsl_data 	NSLsat(nsl_data&);
friend	nsl_data 	NSLsat(nsl_data&,num_type,num_type);
friend	nsl_data 	NSLsat(nsl_data&,nsl_data&,nsl_data&);
friend	nsl_data 	NSLsat(nsl_data&,nsl_data&,nsl_data&,
				nsl_data&,nsl_data&);
friend	nsl_data 	NSLsat(nsl_data&,num_type,num_type,
				num_type,num_type);
friend	nsl_vector 	NSLsat(nsl_vector&,nsl_data&,nsl_data&);
friend	nsl_matrix 	NSLsat(nsl_matrix&,nsl_data&,nsl_data&);
friend	nsl_vector 	NSLsat(nsl_vector&,nsl_vector&,nsl_vector&,
				nsl_data&,nsl_data&);
friend	nsl_matrix 	NSLsat(nsl_matrix&,nsl_matrix&,nsl_matrix&,
				nsl_data&,nsl_data&);
friend	nsl_vector 	NSLsat(nsl_vector&,nsl_data&,nsl_data&,
				nsl_data&,nsl_data&);
friend	nsl_matrix 	NSLsat(nsl_matrix&,nsl_data&,nsl_data&,
				nsl_data&,nsl_data&);

// NSLsigma
friend	nsl_data 	NSLsigma(nsl_data&);
friend	nsl_data 	NSLsigma(nsl_data&,num_type,num_type);
friend	nsl_data 	NSLsigma(nsl_data&,nsl_data&,nsl_data&);
friend	nsl_data 	NSLsigma(nsl_data&,num_type,num_type,
				num_type,num_type);
friend	nsl_data 	NSLsigma(nsl_data&,nsl_data&,nsl_data&,
				nsl_data&,nsl_data&);
friend	nsl_vector 	NSLsigma(nsl_vector&,nsl_data&,nsl_data&);
friend	nsl_matrix 	NSLsigma(nsl_matrix&,nsl_data&,nsl_data&);
friend	nsl_vector 	NSLsigma(nsl_vector&,nsl_vector&,nsl_vector&,
				nsl_data&,nsl_data&);
friend	nsl_matrix 	NSLsigma(nsl_matrix&,nsl_matrix&,nsl_matrix&,
				nsl_data&,nsl_data&);
friend	nsl_vector 	NSLsigma(nsl_vector&,nsl_data&,nsl_data&,
				nsl_data&,nsl_data&);
friend	nsl_matrix 	NSLsigma(nsl_matrix&,nsl_data&,nsl_data&,
				nsl_data&,nsl_data&);

// 	max,min functions

// NSLmax
friend	nsl_data 	NSLmax(nsl_data&,nsl_data&);
friend	nsl_data 	NSLmax(nsl_data&,num_type);
friend	nsl_vector 	NSLmax(nsl_vector&,nsl_data&);
friend	nsl_matrix 	NSLmax(nsl_matrix&,nsl_data&);

// NSLmin
friend	nsl_data 	NSLmin(nsl_data&,nsl_data&);
friend	nsl_data 	NSLmin(nsl_data&,num_type);
friend	nsl_vector 	NSLmin(nsl_vector&,nsl_data&);
friend	nsl_matrix 	NSLmin(nsl_matrix&,nsl_data&);

	// print
friend	ostream& 	operator<<(ostream&,nsl_data&);
friend	istream& 	operator>>(istream&,nsl_data&);

// print data
		void	print(ostream& out);
// print status
	virtual void	print_status(ostream& out); // virtual
		void	print_layer_status(ostream& out); // local

	virtual void	print_stim(ostream&) {}
	virtual void	print_stim(ostream&,int) {}

	virtual nsl_stim_obj* get_stim(int) { return (nsl_stim_obj*) 0; }
	virtual nsl_stim_obj* get_stim(char*) { return (nsl_stim_obj*) 0; }
};

// data list
typedef nsl_data* data_type;
declare(gslist,data_type);

typedef gslist_iterator(data_type) data_type_iterator;
typedef gslist(data_type) data_type_list;

