//
//	nsl_input_data.h
//

// input data
class nsl_input_data : public nsl_data
{
	int overlap_fg;			// overlap
	int stim_total;			// stim list total
	nsl_stim_list* stim_list;	// stim list

public:

	nsl_input_data(char*);
	~nsl_input_data();

// set
	void	set_stim_list(nsl_stim_list* l) { stim_list = l; }
	void	set_overlapfg(int i) { overlap_fg = i; }
// get
	nsl_stim_list*	get_stim_list() { return stim_list; }
	nsl_stim_obj* get_stim(int);
	nsl_stim_obj* get_stim(char*);
	int	get_stim_total() { return stim_total; }
	int	get_overlapfg() { return overlap_fg; }

// 	assignment
void 	operator=(nsl_input_data&);
void 	operator=(nsl_data&);
void 	operator=(num_type);

	void clear_stim();
	void copy_stim(nsl_input_data&);

	nsl_block_data* init_block_stim();
	nsl_icon_data* init_icon_stim();

	void run();

// print status
	void print_status(ostream&); // virtual
	void print_layer_status(ostream&); // local

	void print_stim(ostream&);
	void print_stim(ostream&,int);
};

typedef nsl_input_data NSL_INPUT_DATA;
