//
//	nsl_module.h
//

struct nsl_module
{
	char name[NAME_SIZE];
	int index;
	int able_fg; // 1 - process module, 0 - otherwise
	int time_fg; // 0 - all time, 1 - t = 0 only, 2 - t > 0 only
//	float t0,t1; // time interval

	int verbose_fg; // 1 - run verbose

	void (*mod_func)();

public:
		nsl_module(nsl_model*,char*,void (*)());
		nsl_module(nsl_model&,char*,void (*)());
		nsl_module(nsl_model*,char*,void (*)(),int);
		nsl_module(nsl_model&,char*,void (*)(),int);

		nsl_module(char*,void (*)());
		nsl_module(char*,void (*)(),int);

		~nsl_module();

// set flags
	void 	set_verbose_fg(int i) { verbose_fg = i; }
// get flags
	int  	get_verbose_fg() { return verbose_fg; }

// enable, disable
	void 	enable() { able_fg = 1; }
	void 	disable() { able_fg = 0; }

// set
	void 	set_name(char* str) { strcpy(name,str); }
	void 	set_index(int i) { index = i; }
	void 	set_able_fg(int i) { able_fg = i; }
	void 	set_time_fg(int i) { time_fg = i; }
// get
	char* 	get_name() { return name; }
	int 	get_index() { return index; }
	int 	get_able_fg() { return able_fg; }
	int 	get_time_fg() { return time_fg; }

	void	proc(float);	// run function from simulation
	void	exec(); 	// exec function if specially called

// status
	void	print_status(ostream&);
};

// module list
typedef nsl_module* module_type;
declare(gslist,module_type);

typedef gslist(module_type) module_type_list;
typedef gslist_iterator(module_type) module_type_iterator;

