//
//	nsl_stim_data.h
//

extern class nsl_input_data;

struct nsl_stim_data : public nsl_stim_obj
{
	nsl_input_data* input_data; // parent input matrix

public:

	nsl_stim_data();
	nsl_stim_data(nsl_input_data*);
	~nsl_stim_data();

	void run();
	virtual void proc();

	void print(ostream&);
	virtual void print_stim(ostream&);
};

class nsl_block_data : public nsl_stim_data
{
	float val;			// stim val

public:

	nsl_block_data();
	nsl_block_data(nsl_input_data*);
	~nsl_block_data();

// set
	void	set_val(float s) { val = s; }
// get
	float	get_val() { return val; }

	void proc();

	void print(ostream&);
	virtual void print_stim(ostream&);
};

class nsl_icon_data : public nsl_stim_data
{
	nsl_data* icon;

public:

	nsl_icon_data();
	nsl_icon_data(nsl_input_data*);
	~nsl_icon_data();

	void proc();

	void print(ostream&);
	virtual void print_stim(ostream&);
};
