//
//	nsl_stim_matrix.h
//

extern class nsl_input_matrix;

struct nsl_stim_matrix : public nsl_stim_obj
{
        int type;               	// 0 - (xc,yc),(dx,dy)
                                   	// 1 - (x0,y0),(dx,dy)    
	float x0,y0;			// stim original corner location
	float tx0,ty0;			// stim current corner location
	float xc,yc;			// stim original center location
	float txc,tyc;			// stim current center location
	float vx,vy; 			// stim speed

	nsl_input_matrix* input_matrix; // parent input matrix

public:

	nsl_stim_matrix();
	nsl_stim_matrix(nsl_input_matrix*);
	~nsl_stim_matrix();

// set
	void	set_type(int i) { type = i; }
	void	set_x0(float i) { x0 = i; }
	void	set_y0(float i) { y0 = i; }
	void	set_tx0(float i) { tx0 = i; }
	void	set_ty0(float i) { ty0 = i; }
	void	set_xc(float i) { xc = i; }
	void	set_yc(float i) { yc = i; }
	void	set_txc(float i) { txc = i; }
	void	set_tyc(float i) { tyc = i; }
	void	set_vx(float s) { vx = s; }
	void	set_vy(float s) { vy = s; }

// get
	int	get_type() { return type; }
	float	get_x0() { return x0; }
	float	get_y0() { return y0; }
	float	get_tx0() { return tx0; }
	float	get_ty0() { return ty0; }
	float	get_xc() { return xc; }
	float	get_yc() { return yc; }
	float	get_txc() { return txc; }
	float	get_tyc() { return tyc; }
	float	get_vx() { return vx; }
	float	get_vy() { return vy; }

	void run();
	virtual void proc();

	void print(ostream&);
	virtual void print_stim(ostream&);
};

class nsl_block_matrix : public nsl_stim_matrix
{
	float val;			// stim val
	float dx,dy;			// stim size

public:

	nsl_block_matrix();
	nsl_block_matrix(nsl_input_matrix*);
	~nsl_block_matrix();

// set
	void	set_val(float s) { val = s; }
	void	set_dx(float s) { dx = s; }
	void	set_dy(float s) { dy = s; }
// get
	float	get_val() { return val; }
	float	get_dx() { return dx; }
	float	get_dy() { return dy; }

	void proc();

	void print(ostream&);
	virtual void print_stim(ostream&);
};

class nsl_icon_matrix : public nsl_stim_matrix
{
	nsl_matrix* icon;

public:

	nsl_icon_matrix();
	nsl_icon_matrix(nsl_input_matrix*);
	~nsl_icon_matrix();

	void proc();

	void print(ostream&);
	virtual void print_stim(ostream&);
};
