//
//	nsl_stim_obj.h
//

extern class nsl_stim_obj;

class nsl_time_obj
{
	int index;			// obj index
	int able_fg;			// on - off
	int type;               	// 0 - discrete inputs (t0 is used)
                                        // 1 - input interval (t0<-dt->t1)
	float t0,t1;			// time interval

	nsl_stim_obj* stim_obj;		// parent stimulus

public:

	nsl_time_obj();
	nsl_time_obj(nsl_stim_obj*);
	~nsl_time_obj();

// set
	void	set_index(int i) { index = i; }
	void	set_type(int i) { type = i; }
	void	set_able_fg(int i) { able_fg = i; }
	void	set_t0(float s) { t0 = s; }
	void	set_t1(float s) { t1 = s; }

// get
	int	get_index() { return index; }
	int	get_type() { return type; }
	int	get_able_fg() { return able_fg; }
	float	get_t0() { return t0; }
	float	get_t1() { return t1; }

// enable, disable
	void 	enable() { able_fg = 1; }
	void 	disable() { able_fg = 0; }

	void print(ostream&);
	virtual void print_stim(ostream&);
};

// time list 
typedef nsl_time_obj* nsl_time_ptr;
declare(gslist,nsl_time_ptr);

typedef gslist_iterator(nsl_time_ptr) nsl_time_iterator;
typedef gslist(nsl_time_ptr) nsl_time_list;

struct nsl_stim_obj
{
	string name;			// stim name
	int index;			// obj index
 	int able_fg;			// 1 - process stim, 0 - otherwise
        int add_fg;              	// 1 - overlapping inputs are added
        int mode;               	// 0 - run all time
                                        // 1 - run specified time interval 
	int step;			// recalc step
	int time_total;			// interval list total
	nsl_time_list* time_list;	// interval list

public:

	nsl_stim_obj();
//	nsl_stim_obj(nsl_layer*);
	~nsl_stim_obj();

// set
	void 	set_name(char* str) { strcpy(name,str); }
	void	set_index(int i) { index = i; }
	void	set_able_fg(int i) { able_fg = i; }
	void	set_addfg(int i) { add_fg = i; }
	void	set_mode(int i) { mode = i; }

// get
	char*	get_name() { return name; }
	int	get_index() { return index; }
	int	get_able_fg() { return able_fg; }
	int	get_addfg() { return add_fg; }
	int	get_mode() { return mode; }

// enable, disable
	void 	enable() { able_fg = 1; }
	void 	disable() { able_fg = 0; }

	nsl_time_obj* init_time_interval();

	virtual void run();
	virtual void proc();

	void print(ostream&);
	void print_time(ostream&);
	virtual void print_stim(ostream&);
};

// stim list 
typedef nsl_stim_obj* nsl_stim_ptr;
declare(gslist,nsl_stim_ptr);

typedef gslist_iterator(nsl_stim_ptr) nsl_stim_iterator;
typedef gslist(nsl_stim_ptr) nsl_stim_list;

