//
//	nsl_stim_vector.h
//

extern class nsl_input_vector;

struct nsl_stim_vector : public nsl_stim_obj
{
        int type;               	// 0 - (xc),(dx)
                                   	// 1 - (x0),(dx)    
	float x0;			// stim original corner location
	float tx0;			// stim current corner location
	float xc;			// stim original center location
	float txc;			// stim current center location
	float vx; 			// stim speed

	nsl_input_vector* input_vector; // parent input vector

public:

	nsl_stim_vector();
	nsl_stim_vector(nsl_input_vector*);
	~nsl_stim_vector();

// set
	void	set_type(int i) { type = i; }
	void	set_x0(float i) { x0 = i; }
	void	set_tx0(float i) { tx0 = i; }
	void	set_xc(float i) { xc = i; }
	void	set_txc(float i) { txc = i; }
	void	set_vx(float s) { vx = s; }

// get
	int	get_type() { return type; }
	float	get_x0() { return x0; }
	float	get_tx0() { return tx0; }
	float	get_xc() { return xc; }
	float	get_txc() { return txc; }
	float	get_vx() { return vx; }

	void run();
	virtual void proc();

	void print(ostream&);
	virtual void print_stim(ostream&);
};

class nsl_block_vector : public nsl_stim_vector
{
	float val;			// stim val
	float dx;			// stim size

public:

	nsl_block_vector();
	nsl_block_vector(nsl_input_vector*);
	~nsl_block_vector();

// set
	void	set_val(float s) { val = s; }
	void	set_dx(float s) { dx = s; }
// get
	float	get_val() { return val; }
	float	get_dx() { return dx; }

	void proc();

	void print(ostream&);
	virtual void print_stim(ostream&);
};

class nsl_icon_vector : public nsl_stim_vector
{
	nsl_vector* icon;

public:

	nsl_icon_vector();
	nsl_icon_vector(nsl_input_vector*);
	~nsl_icon_vector();

	void proc();

	void print(ostream&);
	virtual void print_stim(ostream&);
};
