//
// 	nsl_system.h
//

class nsl_system
{
	int model_total; 		 // total number of models
	model_type_list* nsl_model_list; // pointer to all models

// i/o files
	int file_total; 		 // total number of files
	file_type_list* nsl_file_list;   // pointer to file list

	int log_total;			 // total number of open log files
	file_type_list* nsl_log_list;    // pointer to open log file list

// system
	int* argc_ptr;
	char** argv_ptr;
	
// interface
	int server_fg;
	window_interface* interface; // pointer to all models

// graph list
	int graph_total;		// total number of graph types
	data_type_list* nsl_graph_list;	// pointer to all graph types
public:
		nsl_system();
// model
	int 	get_model_total() { return model_total; }
	model_type_list* get_model_list() { return nsl_model_list; }

	int		add_model(nsl_model*);
	nsl_model*	get_model(char*);	// name search
	nsl_model*	get_model(int);		// index search

// i/o file
	int 	get_file_total() { return file_total; }
	file_type_list* get_file_list() { return nsl_file_list; }

	int		add_file(nsl_file*);
	nsl_file*	get_file(char*);	// name search
	nsl_file*	get_file(int);		// index search

	void		print_all_file_status(ostream&);
	void		print_file_status(ostream&,char*);
	void		print_file_status(ostream&,int);

// log file stack
	int 	get_log_total() { return log_total; }
	file_type_list* get_log_list() { return nsl_log_list; }

	int 		push_log_file(nsl_file*);
	nsl_file*	pop_log_file();

	void		print_log_file_status(ostream&);

// system
	void set_argc_ptr(int* ptr) { argc_ptr = ptr; }
	int* get_argc_ptr() { return argc_ptr; }
	void set_argv_ptr(char** ptr) { argv_ptr = ptr; }
	char** get_argv_ptr() { return argv_ptr; }

// interface
	void set_server_fg(int i) { server_fg = i; }
	int get_server_fg() { return server_fg; }
	window_interface* get_interface() { return interface; }

// graph list
	int 	get_graph_total() { return graph_total; }
	data_type_list* get_graph_list() { return nsl_graph_list; }

	int 	init_graph_list();
	int 	set_graph(char*);
	int 	add_graph(nsl_data*);
	nsl_data* get_graph(char*);
	nsl_data* get_graph(int);
	void	print_graph_list();

// model

// enable,disable
	void enable_all_model(); 	// enable all models
	void enable_model(char*); 	// enable name model
	void enable_model(int);		// enable index model
	void disable_all_model(); 	// disable all models
	void disable_model(char*);	// disable name model
	void disable_model(int);	// disable index model

// print status
	void print_status(ostream&);
	void print_interface_status(ostream&);
	void print_model_status(ostream&);
	void print_all_model_status(ostream&);
	void print_model_status(ostream&,char*);
	void print_model_status(ostream&,int);
};
