//
// 	panel_object.h
//

// general window object to be displayed on a canvas

extern class display_window;
extern class display_panel;

struct panel_object
{
	display_window* parent_window;	//  parent display window
	display_panel* parent_panel;	//  parent display panel
	Panel main_panel;		//  main panel
	Scrollable_panel data_panel;	//  data panel

	int able_fg; 			// 1 - enable
	string  type_str;		// window type name
	string  name;			// window name
	int index;			// object index
public:
		panel_object(display_window*,char*,char*,int);
		~panel_object();

        virtual void set_wx(int) {}
        virtual void set_wy(int) {}
        virtual int get_wx() { return 0; }
        virtual int get_wy() { return 0; }

	void	set_able_fg(int fg) { able_fg = fg; }
	void	set_index(int i) { index = i; }
	void	set_type_str(char* str) { strcpy(type_str,str); }
	void	set_name(char* str) { strcpy(name,str); }

	int	get_able_fg() { return able_fg; }
	int 	get_index() { return index; }
	char* 	get_name() { return name; }
	char* 	get_type_str() { return type_str; }

	void 	enable() { able_fg = 1; }
	void 	disable() { able_fg = 0; }

	virtual void	print(ostream&);
	virtual void	read_from_database() {}
	virtual void	write_to_database() {}
	virtual void	init() {}
	virtual void	display() {}
	virtual void	display(int its,float dt) {}
	virtual void	display(int it0,int it1,float dt) {}
// draw
	virtual void batch() {}
	virtual void draw(num_type,num_type) {}
	virtual void draw(num_type,num_type,int,float) {}
};

// panel lists

typedef panel_object* panel_type;
declare(gslist,panel_type);

typedef gslist(panel_type) panel_type_list;
typedef gslist_iterator(panel_type) panel_type_iterator;

