;# ***************************************************************************
;#			    SBL2
;#
;#	refer to SBL2/sbl2_simp.C
;# 	Last update: MARCH 5th, 97.
;#
;#
;# ***************************************************************************


# set network SBL2

nslset SBL2 delta 1 		;#  **** Time Step msec.
nslset SBL2 end_time 300  	;#  Total simulation time =  sec




;#;#;#;#;#;#;#;#;#;#;#;#;#;#;#;#/  SCHEMAS  ;#;#;#;#;#;#;#;#;#;#;#;#;#;#;#;#;#

nslset noise value 0.1	;# noise on schema activations.

nslset th_sch value 0.9	;# Threshold



;#;#;#;#;#;#;#;#;# LAYERS ;#;#;#;#;#;#;#;#;#

nslset tune_tm value 0.3 	;#0: cyclic forward mode 0.5: cyclic sidestep.

nslset Field_A value 1.5
nslset Field_center value 30  ;#20

nslset prey_norm value 11     ;# Normalazing factors.
nslset gaps_norm value 170


;#;#;#;#;#;#;#;#;#;#;#;# ENVIRONMENT ;#;#;#;#;#;#;#;#;#;#;#;#;#;#;#

nslset xf value 110    ;# COORDINATES of the frog   130, 170 (moved)
nslset yf value 160
nslset xw value 110    ;# coordinates of the worm. 130, 155 (moved)
nslset yw value  90
nslset xpr value 90    ;# coordinates of the predator.
nslset ypr value 90


nslset frog_forward value 9           ;# Forward step  3
nslset frog_speed value 3             ;# Backup step   6
nslset worm_speed value 0                     ;#2
nslset step value 1                   ;# step of the worm.



;# BARRIER:

nslset xb_init value 75       ;#10 cm:90  20cm: 75 coordinates of barrier.
nslset yb value 110           ;#30 cm: 60
nslset barrier value 20       ;#barrier size.
nslset gap_ value 5           ;# intergap distance


nslset edge value -3          ;# area considered edge. 
nslset safe_distance value 5  ;#30



nslset boundary_ value 140    ;# boundary not to get out of the world.



;#;#;#;#;#;#;#;#;#;#;#;#;#/ KERNELS ;#;#;#;#;#;#;#;#;#;#;#;#;#;#;#;#


nslset Gradient value \
15 15 14 14 13 13 12 12 11 11 10 10 9 9 8 8 7 7 7 6 6 6 5 5 5 4 4 4 3 3 3 2 2 2 1 1 1 0 0 0 0 0 0 -1 -1 -1 -2 -2 -2 -3 -3 -3 -4 -4 -4 -5 -5 -5 -6 -6 -6  -7 -7 -7 -8 -8 -9 -9 -10 -10 -11 -11 -12 -12 -13 -13 -14 -14 -15 -15


nslset Prey_hor value  \
0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0.546152 1.1244 2.28088 3.50135 4.23923 5.00773  \
5.80559 6.63129 7.48308 8.35898 8.71064 9.04973 9.37369 9.67999 9.96617        \
10.2299 10.469 10.6813 10.8652 11.0189 11.1411 11.2308 11.3071 11.4095         \
11.3078 11.2521 11.1729 11.0609 10.917 10.7425 10.539 10.3082 10.0521 9.77291  \
9.47284 9.15435 8.81995 8.47218 8.11364 7.74688 6.89172 6.06433 4.78368 3.5649 \
2.89121 2.24898 1.63865 1.0604 0.514251 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 


;#nslset complement value    \              
;#0 0 0 2 0 0 0 0 0 0 0 0 0 0 0   ;# for reorientation

nslset t5_2_erf_dia value  \
40
nslset t5_2_erf_sig value  \
18				;# 10 grande (muro)
				;# 18 pequenia
				;# 5 for (afer move)	
nslset t5_2_erf_wgt value  \
1.3				;# 0.2 for 20 cm
				;# 1.3 for 10 cm

# nslset t5_w value   0.5
                             ;#t5 over tegmentum




nslset tm_irf_dia value    38

			
nslset tm_irf_sig value   1.5
					;# 1 for 20 cm
					;# 1.5 for 10 cm
					;# Gaussian NOT 2DG.
nslset tm_irf_wgt value    \
2.0					;# 2.0 for 10 cm orienting          	
					;# 0.2 for 20 cm?






nslload sbl_sti.tcl

nslcreate window_interface
