/************************************/
/*           didday_new.C           */
/************************************/

# include "nsl_new_include.h"

nsl_neural_network DIDDAY("DIDDAY",1);
nsl_neuron_vector U("U",10);
nsl_neuron_data V("V");
nsl_num_vector S("S",10,1); // init in .nsl file
nsl_num_data  w1("w1",1),w2("w2",1);


SYS_MODULE(didday_sys)
{
	NSLconnect(U,U,w1,1);
	NSLconnect(U,V,w2,-1);
	NSLconnect(U,S,1);
	NSLconnect(V,U,1);

//	DIDDAY.set_integration("EULER"); // add to nsl_model class
	DIDDAY.set_delta(0.1);
	DIDDAY.set_end_time(20.0);

	U.set_output_func("step",0.1);
	U.set_tm(1.0);
	U.set_delta(0.1);
	U.set_h(0.1);

	V.set_output_func("ramp");
	V.set_tm(1.0);
	V.set_delta(0.1);
	V.set_h(0.5);
}
RUN_MODULE(didday_run)
{
	DIDDAY.run(); // 1 step
}

