/****************************************************************/
/*                                                           	*/
/*                       	house.C                         */
/*                                                            	*/
/****************************************************************/

# define CUE_SIZE 81
# define RETINA_SIZE 161

# include "nsl_include.h"

extern void view_to_right_retina(nsl_vector&,nsl_matrix&,
	nsl_data&,nsl_data&,nsl_data&);
extern void view_to_left_retina(nsl_vector&,nsl_matrix&,
	nsl_data&,nsl_data&,nsl_data&);
extern void retina_to_accommodation(nsl_matrix&,nsl_matrix&,nsl_vector&,
	nsl_data&,nsl_data&,nsl_data&,nsl_data&,nsl_data&);
extern void retina_to_disparity(nsl_matrix&,nsl_vector&,nsl_vector&);

NETWORK(HOUSE);

MATRIX(IN,CUE_SIZE,CUE_SIZE);	// network input 
VECTOR(RL,RETINA_SIZE); 	// left retina
VECTOR(RR,RETINA_SIZE); 	// right retina

MATRIX(A,CUE_SIZE,CUE_SIZE); 	// accommodation layer
MATRIX(D,CUE_SIZE,CUE_SIZE); 	// disparity layer

// MATRIX(AOUT,CUE_SIZE,CUE_SIZE); // accommodation output layer
// MATRIX(DOUT,CUE_SIZE,CUE_SIZE); // disparity output layer
// MATRIX(OUT,CUE_SIZE,CUE_SIZE); // output layer

DATA(w); 	// = 3.0;	1/2 of interpupilary distance (cm)
DATA(yf);	// = -10.0;	intersection of optical axes (0,yf) (cm)
DATA(l);	// = 22.0;	distance of interpupilary line from origin (cm)
DATA(dmax);	// = 0.25;	// maximum disparity
DATA(sigma);	// = 0.25;	// spread parameter

INIT_MODULE(cue_init)
{
	RR = 0;
	RL = 0;
	A = 0;
	D = 0;
}
INIT_MODULE(cue_RR)
{
	view_to_right_retina(RR,IN,w,yf,l);
}
INIT_MODULE(cue_RL)
{
	view_to_left_retina(RL,IN,w,yf,l);
}
INIT_MODULE(cue_A)
{
	retina_to_accommodation(A,IN,RR,w,yf,l,dmax,sigma);
}
INIT_MODULE(cue_D)
{
 	retina_to_disparity(D,RR,RL);
}

/*
END_MODULE(cue_AOUT)
{
	k = 0.5;	// threshold
	AOUT = retina_to_view(A,yf,w,l,k);
}
END_MODULE(cue_DOUT)
{
	k = 0.5;	// threshold
	DOUT = retina_to_view(D,yf,w,l,k);
}
END_MODULE(cue_OUT)
{
	k = 0.5;
	OUT = retina_to_view(M,k);
}
*/
