# NSL2.8: house.tcl
# AW - 4/95

# assign neural_network HOUSE	;# model

assign HOUSE delta 0.05		;# simulation delta
assign HOUSE end_time 1.0	;# simulation end_time

create neuron_matrix M 11 11 	;# accommodation layer
create neuron_matrix S 11 11 	;# disparity layer

create neuron_vector U 11 	;# inhibition to accommodation layer
create neuron_vector V 11 	;# inhibition to disparity layer

create num_vector Ws 3
create num_vector Wm 3

create num_data Kmu
create num_data Ksv
create num_data Kds
create num_data Kvs
create num_data Kms
create num_data Kam
create num_data Kum
create num_data Ksm

connect M A Kam 1	;# M <- + Kam*A
connect M U Kum -1	;# M <- - Kum*U
connect M S Ksm 1	;# M <- + Ksm*S
connect M M Wm 1	;# M <- + Wm*M
connect U M Kmu 1	;# U <- + Kmu*M

connect S D Kds 1	;# S <- + Kds*D
connect S V Kvs -1	;# S <- - Kvs*V
connect S M Kms 1	;# S <- + Kms*M
connect S S Ws 1	;# S <- + Ws*S
connect V S Ksv 1	;# V <- + Ksv*S

assign M diff_model leaky
assign M diff_method euler
assign M diff_delta 0.05 	
assign M thresh sigma 0.1 1.1 0 1
assign M tm 0.3			;# assign data_value tm 1.0

assign U diff_model leaky
assign U diff_method euler
assign U diff_delta 0.05 	
assign U thresh ramp 0 0 0	
assign U tm 0.1			;# assign data_value tm 1.0

assign S diff_model leaky
assign S diff_method euler
assign S diff_delta 0.05 	
assign S thresh sigma 0.1 1.1 0 1
assign S tm 0.3			;# assign data_value tm 1.0

assign V diff_model leaky
assign V diff_method euler
assign V diff_delta 0.05 	
assign V thresh ramp 0 0 0
assign V tm 0.1			;# assign data_value tm 1.0

assign w value 3.0	 ;# 1/2 of interpupilary distance in cm 
assign yf value -10.0	 ;# intersection of optical axes  (0,yf)  in cm   	
assign l value 22.0	 ;# distance of interpupilary line from origin in cm
assign dmax value 0.25	 ;# maximum disparity
assign sigma value 0.25	 ;# spread parameter

assign Ws value 0.25 0.68 0.25
assign Wm value 0.25 0.68 0.25

assign Kmu value 1.0
assign Ksv value 1.0
assign Kds value 0.5
assign Kvs value 0.6
assign Kms value 0.8
assign Kam value 0.5
assign Kum value 0.6
assign Ksm value 0.8

assign IN single_value 0

# prey

# assign IN region_single_value 35 35 41 41 1.0
# assign IN region_single_value 45 45 55 55 1.0

assign IN region_single_value 0 0 0 0 1.0
assign IN region_single_value 10 10 10 10 1.0

# barrier

# assign IN region_single_value 35 35 30 50 1.0

#	assign_all_layer_file_sector (44,52,45,65)

create window_interface

# assign frame_X0 250
# assign frame_Y0 100
assign display_frame width 450
assign display_frame height 600
# assign frame_rows 1
create display_frame .house0

assign display_window layer IN
assign display_window graph area_level_graph
assign display_window wymin 0
assign display_window wymax 1
create display_window .house0.in

# assign display_frame X0 700
# assign display_frame Y0 100
assign display_frame width 450
assign display_frame height 300
# assign display_frame rows 2
create display_frame .house1

assign display_window layer U_out
assign display_window graph spatial_graph_2
assign display_window wymin 0
assign display_window wymax 1
# assign display_window layer_i0 35
# assign display_window layer_i1 50
create display_window .house1.u_out

assign display_window layer V_out
assign display_window graph spatial_graph_2
assign display_window wymin 0
assign display_window wymax 1
# assign display_window layer_i0 35
# assign display_window layer_i1 50
create display_window .house1.v_out

# assign display_frame X0 700
# assign display_frame Y0 400
assign display_frame width 450
assign display_frame height 300
# assign display_frame rows 2
create display_frame .house2

assign display_window layer M_out
assign display_window graph spatial_graph_3
assign display_window wymin -1
assign display_window wymax 1
assign display_window sz 10
assign display_window hidden NSL_ON
# assign display_window layer_i0 20
# assign display_window layer_i1 80
# assign display_window layer_j0 35
# assign display_window layer_j1 50
create display_window .house2.m_out

assign display_window layer S_out
assign display_window graph spatial_graph_3
assign display_window wymin -1
assign display_window wymax 1
assign display_window sz 10
assign display_window hidden NSL_ON
# assign display_window layer_i0 20
# assign display_window layer_i1 80
# assign display_window layer_j0 35
# assign display_window layer_j1 50
create display_window .house2.s_out

# added because of crashing at the end of execution (!?)

run 1.0
